/******************************************************************************
*
*  Rectify.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modRectifier;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      RectifyFX;

RectifyFX:
    I2 = DM(p_RectifyFX);
    AX1 = DM(I2, M1);
    DM(p_RectifyFX) = I2;
    AR = DM(I7, M6);
    AR = abs AR;
    NONE = pass AX1;
    if EQ jump PosRectify;
    
NegRectify:
    AR = -AR;
    DM(I7, M6) = AR;
    rts;
    
PosRectify:
    DM(I7, M6) = AR;
    rts;
        
.ENDMOD;