/******************************************************************************
*
*  WTGen2.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modWTGen2;


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */

.ENTRY      WTGen2;

WTGen2:
    I2 = DM(p_WTGen2);
    MR1 = DM(I2, M1);                       /* get freq/phase */
    dis AR_SAT, ena M_MODE;
    MY0 = 0x7ae0;
    MR=MR+MR1*MY0 (UU), AY0=DM(I2, M0);     /* get oldphase */
    AR = MR1 + AY0;                         /* inc phase */
    MY0 = 128;
    DM(I2,M1)=AR, MR=AR*MY0 (UU);           /* writeback ph, get LUT offset */

    AY0 = DM(I2, M1);                       /* base of LUT */
    AR = MR1 + AY0;
    I3 = AR;

    AY0 = DM(I3, M1);                       /* LUT(n) */
    AX0 = DM(I3, M1);                       /* LUT(n+1) */
    MY0=MR0, AR=AX0-AY0;                    /* get difference */

    MR = AR * MY0 (SU);                    /* scale to interpolate */
    
    ena AR_SAT, dis M_MODE;
    
    AR = MR1 + AY0;                         /* AR = interpolated output */
    DM(I7, M6) = AR;
    
    DM(p_WTGen2) = I2;
    
    rts;

.ENDMOD;