/******************************************************************************
*
*  templatevars.h
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  place all newly created project-specific variables and functions here.  this
*  would include variables that might be needed in song control and functions
*  that are called by the sequencer during initialization (those in
*  TrigInit.dsp).
*
******************************************************************************/

#ifndef SONGVAR_FUNC

/*
 *  place .external declarations in here to avoid compilation errors
 */

.EXTERNAL   InitBD1_29;
.EXTERNAL   InitBD2_29;
.EXTERNAL   InitRot1_29;
.EXTERNAL   InitRot2_29;
.EXTERNAL   InitRot3_29;
.EXTERNAL   InitRot4_29;
.EXTERNAL   InitRot5_29;
.EXTERNAL   InitRot6_29;
.EXTERNAL   InitOC4_29;
.EXTERNAL   InitKS1_29;
.EXTERNAL   InitKS2_29;
.EXTERNAL   InitKS5_29;
.EXTERNAL   InitKS6_29;

.EXTERNAL   v_DelayCNTR;
.EXTERNAL   v_ModLead1_29;
.EXTERNAL   v_ModLead2_29;
.EXTERNAL   v_ModPeriod1_29;
.EXTERNAL   v_ModPeriod2_29;
.EXTERNAL   v_ModBD1_29;
.EXTERNAL   v_BDModPeriod1_29;
.EXTERNAL   v_ModBD2_29;
.EXTERNAL   v_BDModPeriod2_29;
.EXTERNAL   v_ModOscComb_29;
.EXTERNAL   v_ModOscCombPeriod_29;
.EXTERNAL   v_OCMask1_29;
.EXTERNAL   v_OCMask2_29;
.EXTERNAL   v_OCMask3_29;
.EXTERNAL   v_ProbModOC2_29;
.EXTERNAL   v_KSMask1_29;
.EXTERNAL   v_VolKS1_29;
.EXTERNAL   v_KSMask2_29;
.EXTERNAL   v_VolKS2_29;
.EXTERNAL   v_TrigKS3_29;
.EXTERNAL   v_KSPeriod3_29;
.EXTERNAL   v_KSMask3_29;
.EXTERNAL   v_KS3Count_29;
.EXTERNAL   v_TrigKS4_29;
.EXTERNAL   v_KSPeriod4_29;
.EXTERNAL   v_KSMask4_29;
.EXTERNAL   v_KS4Count_29;
.EXTERNAL   v_RotMask2_29;
.EXTERNAL   v_BaseScalarKS3_29;
.EXTERNAL   v_BaseScalarKS4_29;
.EXTERNAL   v_FABCNTR_29;
.EXTERNAL   v_ModParamPeriod_29;
.EXTERNAL   v_SongCNTR_29;
.EXTERNAL   v_ProbLowBD1_29;
.EXTERNAL   v_ProbLowBD2_29;
.EXTERNAL   v_SongCTRL1;

#endif