.MODULE/abs=0                               modVolEnvTest;

#define         VOLENV_VARS                 5

.VAR/DM         a_VolEnv[32*VOLENV_VARS];
.GLOBAL         a_VolEnv;

.VAR/DM         p_VolEnv;
.GLOBAL         p_VolEnv;

.VAR/DM         v_TestAddr1;
.VAR/DM         v_TestAddr2;

.VAR/DM         a_Out[32];

.EXTERNAL       VolEnv;

#define SET_VOLENV(offset, start, end, time) \
    ena M_MODE; \
    MX1 = offset; \
    MY1 = VOLENV_VARS; \
    MR = MX1 * MY1 (UU); \
    dis M_MODE; \
    M2 = MR1; \
    I2 = ^a_VolEnv; \
    modify(I2, M2); \
    DM(I2, M1) = ^a_Out+offset; \
    DM(I2, M1) = 0; \
    DM(I2, M1) = start; \
    DM(I2, M1) = end; \
    DM(I2, M1) = time

/*
 *  init seq arrays (trigtrack and a_seq)
 *  can random number generator, create buffer of noise
 *  enter infinite loop, watch how things trigger
 */


    jump main; rti; rti; rti;
    rti;       rti; rti; rti;
    rti;       rti; rti; rti;
    rti;       rti; rti; rti;
    rti;       rti; rti; rti;
    rti;       rti; rti; rti;
    rti;       rti; rti; rti;
    rti;       rti; rti; rti;
    rti;       rti; rti; rti;
    rti;       rti; rti; rti;
    rti;       rti; rti; rti;
    rti;       rti; rti; rti;

main:
    L0 = 0; L1 = 0; L2 = 0; L3 = 0;
    L4 = 0; L5 = 0; L6 = 0; L7 = 0;

    M0 = 0; M1 = 1; M6 = 0; M7 = 1;

    /* ALU saturation, go mode, fractional multiplies */
    ena AR_SAT, dis M_MODE;
    ena G_MODE;

    IMASK = 0;

    SET_VOLENV(1, 0x0000, 0x7fff, 7);

    AR = ^a_VolEnv;
    DM(p_VolEnv) = AR;

StartVolEnv:

    CNTR = 100;
    do VE1 until CE;
      call VolEnv;
            
      AR = ^a_VolEnv;
VE1:  DM(p_VolEnv) = AR;

    jump StartVolEnv;

.ENDMOD;
