/******************************************************************************
*
*  IRQEProc.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  custom IRQE processing.  place any irqe interrupt code here.
*
******************************************************************************/

.MODULE                                     modIRQEProc;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "flb.h"

/*
 *  external functions and variables
 */

.EXTERNAL   v_NextSong;

/*
 *  entry points
 */

.ENTRY      IRQEProc;

IRQEProc:
    /*  IRQE forces movement to next song in SongPtrs list */
    DM(v_NextSong) = M1;

    rts;
      
.ENDMOD;
