/******************************************************************************
*
*  TrigInit.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  functions called when track is retriggered.  pointers to these functions are
*  placed in the a_Seq2 array.
*
******************************************************************************/

.MODULE                                     modTrigInit_00;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "flb.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      InitTrack00;
.ENTRY      InitTrack01;
.ENTRY      InitTrack02;
.ENTRY      InitTrack03;
.ENTRY      InitTrack04;
.ENTRY      InitTrack05;
.ENTRY      InitTrack06;
.ENTRY      InitTrack07;
.ENTRY      InitTrack08;
.ENTRY      InitTrack09;
.ENTRY      InitTrack10;
.ENTRY      InitTrack11;
.ENTRY      InitTrack12;
.ENTRY      InitTrack13;
.ENTRY      InitTrack14;
.ENTRY      InitTrack15;
.ENTRY      InitTrack16;
.ENTRY      InitTrack17;
.ENTRY      InitTrack18;
.ENTRY      InitTrack19;
.ENTRY      InitTrack20;
.ENTRY      InitTrack21;
.ENTRY      InitTrack22;
.ENTRY      InitTrack23;
.ENTRY      InitTrack24;
.ENTRY      InitTrack25;
.ENTRY      InitTrack26;
.ENTRY      InitTrack27;
.ENTRY      InitTrack28;
.ENTRY      InitTrack29;
.ENTRY      InitTrack30;
.ENTRY      InitTrack31;

TrigInit_00:

InitTrack00:
    RESET_PHASE_WTGEN2(0);
    RESET_MEMENV3(0);
    rts;
    
InitTrack01:
    RESET_PHASE_WTGEN2(1);
    RESET_MEMENV3(1);
    rts;
    
InitTrack02:
    RESET_PHASE_WTGEN2(2);
    RESET_MEMENV3(2);
    rts;
    
InitTrack03:
    RESET_PHASE_WTGEN2(3);
    RESET_MEMENV3(3);
    rts;
    
InitTrack04:
    RESET_PHASE_WTGEN2(4);
    RESET_MEMENV3(4);
    rts;
    
InitTrack05:
    RESET_PHASE_WTGEN2(5);
    RESET_MEMENV3(5);
    rts;

InitTrack06:
    RESET_KSGEN(0);
    RESET_MEMENV3(6);
    AR = DM(I6, M7);
    MY0 = 4;
    MR = AR * MY0 (UU);
    SR = lshift MR1 by -1 (LO);
    I5 = ^a_KS0LFreq;
    M5 = SR0;
    modify(I5, M5);
    AR = DM(I5, M6);
    DM(a_ProbKSGen+((0*PROBKSGEN_VARS)+PROBKSGEN_FREQ)) = AR;
    rts;
    
InitTrack07:
    RESET_KSGEN(1);
    RESET_MEMENV3(7);
    AR = DM(I6, M7);
    MY0 = 4;
    MR = AR * MY0 (UU);
    SR = lshift MR1 by -1 (LO);
    I5 = ^a_KS0RFreq;
    M5 = SR0;
    modify(I5, M5);
    AR = DM(I5, M6);
    DM(a_ProbKSGen+((1*PROBKSGEN_VARS)+PROBKSGEN_FREQ)) = AR;
    rts;

InitTrack11:
    RESET_KSGEN(2);
    RESET_MEMENV3(8);
    AR = DM(I6, M7);
    MY0 = 4;
    MR = AR * MY0 (UU);
    SR = lshift MR1 by -1 (LO);
    I5 = ^a_KS0LFreq;
    M5 = SR0;
    modify(I5, M5);
    AR = DM(I5, M6);
    DM(a_ProbKSGen+((2*PROBKSGEN_VARS)+PROBKSGEN_FREQ)) = AR;
    rts;
    
InitTrack12:
    RESET_KSGEN(3);
    RESET_MEMENV3(9);
    AR = DM(I6, M7);
    MY0 = 4;
    MR = AR * MY0 (UU);
    SR = lshift MR1 by -1 (LO);
    I5 = ^a_KS0RFreq;
    M5 = SR0;
    modify(I5, M5);
    AR = DM(I5, M6);
    DM(a_ProbKSGen+((3*PROBKSGEN_VARS)+PROBKSGEN_FREQ)) = AR;
    rts;

InitTrack08:
    AR = DM(I6, M7);
    MY0 = 0x0004;
    MR = AR * MY0 (UU);
    AR = MR1 + 4;
    MY0 = 25;
    MR = AR * MY0 (UU);
    SR = ashift MR0 by -1 (LO);
    DM(a_FM2Op0Gen + ((0*FM2OP0_VARS)+FM2OP0_MODFREQ)) = SR0;
    RESET_FM2OP0GEN(0);
    rts;
    
InitTrack09:
    AR = DM(I6, M7);
    MY0 = 0x0006;
    MR = AR * MY0 (UU);
    AR = MR1 + 4;
    MY0 = 25;
    MR = AR * MY0 (UU);
    SR = ashift MR0 by -1 (LO);
    DM(a_FM2Op0Gen + ((1*FM2OP0_VARS)+FM2OP0_MODFREQ)) = SR0;
    RESET_FM2OP0GEN(1);
    rts;

InitTrack13:
    AR = DM(I6, M7);
    MY0 = 0x0004;
    MR = AR * MY0 (UU);
    AR = MR1 + 4;
    MY0 = 25;
    MR = AR * MY0 (UU);
    SR = ashift MR0 by -1 (LO);
    DM(a_FM2Op0Gen + ((2*FM2OP0_VARS)+FM2OP0_MODFREQ)) = SR0;
    RESET_FM2OP0GEN(2);
    rts;
    
InitTrack14:
    AR = DM(I6, M7);
    MY0 = 0x0006;
    MR = AR * MY0 (UU);
    AR = MR1 + 4;
    MY0 = 25;
    MR = AR * MY0 (UU);
    SR = ashift MR0 by -1 (LO);
    DM(a_FM2Op0Gen + ((3*FM2OP0_VARS)+FM2OP0_MODFREQ)) = SR0;
    RESET_FM2OP0GEN(3);
    rts;
    
InitTrack10:
    RESET_PHASE_WTGEN2(6);
    RESET_MEMENV2(0);
    rts;

InitTrack15:
InitTrack16:
    AR = DM(a_VolTrack15+0);
    AY0 = 0x100;
    NONE = AR - AY0;
    if GT set FL1;
    AR = DM(a_VolTrack15+1);
    AY0 = 0x100;
    NONE = AR - AY0;
    if GT set FL1;
    AR = DM(a_VolTrack16+0);
    AY0 = 0x100;
    NONE = AR - AY0;
    if GT set FL1;
    AR = DM(a_VolTrack16+1);
    AY0 = 0x100;
    NONE = AR - AY0;
    if GT set FL1;
    rts;

InitTrack17:
    rts;
    
InitTrack18:
    rts;
    
InitTrack19:
    rts;
    
InitTrack20:
    rts;
    
InitTrack21:
    rts;
    
InitTrack22:
    rts;
    
InitTrack23:
    rts;
    
InitTrack24:
    rts;
    
InitTrack25:
    rts;
    
InitTrack26:
    rts;
    
InitTrack27:
    rts;
    
InitTrack28:
    rts;
    
InitTrack29:
    rts;
    
InitTrack30:
    rts;
    
InitTrack31:
    rts;

.ENDMOD;
