/******************************************************************************
*
*  ModFucns.dsp
*  
*  generative music initializing routine
*
******************************************************************************/

.MODULE                                     modModFuncs_29;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "new29.h"

/*
 *  external variables and functions
 */

.EXTERNAL   ModOscCombx_29;
.EXTERNAL   TrigKS3_29;
.EXTERNAL   TrigKS4_29;
.EXTERNAL   SongCTRL_29;

/*
 *  entry points
 */
 
.ENTRY      ModFuncs_29;

ModFuncs_29:
    call Seq2;
    call SongCTRL_29;
        
    call TrigKS3_29;
    call TrigKS4_29;
        
    call ModOscCombx_29;
    
    AR = DM(v_CurrMeasure);
    MY0 = 2;
    MR = AR * MY0 (SS);
    AY0 = 17;
    AR = MR0 + AY0;
    DM(a_LFO3+(0*LFO3_VARS)+LFO3_FREQ) = AR;
    
    AR = AR + 1;
    DM(a_LFO3+(1*LFO3_VARS)+LFO3_FREQ) = AR;
        
    CNTR = DM(v_NumMemEnv1);
    do ME1C until CE;
      call MemEnv1;
ME1C: nop;

    CNTR = DM(v_NumMemEnv2);
    do ME2C until CE;
      call MemEnv2;
ME2C: nop;
    
    CNTR = DM(v_NumMemEnv3);
    do ME3C until CE;
      call MemEnv3;
ME3C: nop;

    CNTR = DM(v_NumLFO3);
    do L3C until CE;
      call LFO3;
L3C:  nop;

    
    rts;
    
.ENDMOD;
