/******************************************************************************
*
*  TrigInit.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  functions called when track is retriggered.  pointers to these functions are
*  placed in the a_Seq2 array.
*
******************************************************************************/

.MODULE                                     modTrigInit_00;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "presettest.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY       init_BASS_DRUM1_0;
.ENTRY       init_BASS_DRUM0_1;
.ENTRY       init_KS_DRUM0_2;
.ENTRY       init_HH_REV_FILTERED_NOISE0_3;
.ENTRY       init_HH_REV_FILTERED_NOISE0_4;

TrigInit_00:

init_BASS_DRUM1_0:
    RESET_MEMENV2(0);
    rts;

init_BASS_DRUM0_1:
    RESET_PHASE_WTGEN2(0);
    RESET_MEMENV2(1);
    rts;

init_KS_DRUM0_2:
    RESET_KSGEN(0);
    rts;

init_HH_REV_FILTERED_NOISE0_3:
    rts;

init_HH_REV_FILTERED_NOISE0_4:
    rts;


.ENDMOD;
