/******************************************************************************
*
*  ModOscComb.dsp
*  
*  generative music modified for OscCombs
*
******************************************************************************/

.MODULE                                     modModOscComb1_29;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "t29.h"

/*
 *  external variables and functions
 */

.EXTERNAL   v_ModOscComb_29;
.EXTERNAL   v_ModOscCombPeriod_29;
.EXTERNAL   a_OscCombGen;
.EXTERNAL   v_ProbModOC2_29;

/*
 *  entry points
 */
 
.ENTRY      ModOscCombx_29;

ModOscCombx_29:
    AR = DM(v_ModOscComb_29);
    AR = AR + 1;
    DM(v_ModOscComb_29) = AR;
    AY0 = DM(v_ModOscCombPeriod_29);
    AR = AR - AY0;
    if LT rts;
    
ResetOscComb:
    DM(v_ModOscComb_29) = M0;

    AR = DM(I6, M7);
    MY0 = 50;
    MR = AR * MY0 (UU);
    
    AY0 = DM(v_ProbModOC2_29);
    NONE = MR1 - AY0;
    if GE rts;
    
    AR = DM(I6, M7);
    AY0 = 0x0003;
    AR = AR and AY0;
    
    AR = AR - 1;
    if LT jump FMModOC2;
    AR = AR - 1;
    if LT jump XOROC2;
    AR = AR - 1;
    if LT jump ANDOC2;

OROC2:
    AR = OSCCOMBGEN_OR;
    DM(a_OscCombGen+(1*OSCCOMBGEN_VARS)+OSCCOMBGEN_COMBTYPE) = AR;
    rts;

FMModOC2:
    AR = OSCCOMBGEN_MULT;
    DM(a_OscCombGen+(1*OSCCOMBGEN_VARS)+OSCCOMBGEN_COMBTYPE) = AR;
    rts;

XOROC2:
    AR = OSCCOMBGEN_XOR;
    DM(a_OscCombGen+(1*OSCCOMBGEN_VARS)+OSCCOMBGEN_COMBTYPE) = AR;
    rts;

ANDOC2:
    AR = OSCCOMBGEN_AND;
    DM(a_OscCombGen+(1*OSCCOMBGEN_VARS)+OSCCOMBGEN_COMBTYPE) = AR;
    rts;

.ENDMOD;
